#include "DesktopSaver.h"

// One note on the DesktopSaver class: it isn't a very good idea
// to make a preview of it: it's slow, it doesn't look very good
// and it doesn't repaint correctly

DesktopSaver::DesktopSaver(BlanketModule *owner, BView* v, bigtime_t snoozetime)
 : BlanketModule::Saver(owner, v, snoozetime), screenbitmap(0), firsttick(true)
{
}

DesktopSaver::~DesktopSaver()
{
	if(screenbitmap != 0)
		delete screenbitmap;
}

void DesktopSaver::Initialize()
{
	color_space	color;
	BRect		frame;

	BScreen	*s = new BScreen(B_MAIN_SCREEN_ID);
	frame = s->Frame();
	color = s->ColorSpace();
	delete s;

	screenbitmap = new BBitmap(frame, color);
	_get_screen_bitmap_(screenbitmap, frame, true);

	BlanketModule::Saver::Initialize();	// this shows the saver view's window
}

void DesktopSaver::Tick()
{
	BlanketModule::Saver::Tick();
	if(firsttick)
	{
		if(screenbitmap && View()->Window()->Lock())
		{
			View()->DrawBitmap(screenbitmap, screenbitmap->Bounds(), View()->Bounds());
			View()->Window()->Unlock();
		}

		firsttick = false;
	}
}
