#include "Fader.h"

// MAIN INSTANTIATION FUNCTION
BArchivable *BlanketModule::Instantiate(BMessage* message)
{
	return new Fader(message);
}

FaderSaver::FaderSaver(BlanketModule *owner, BView* v)
 : BlanketModule::Saver(owner, v, 200000), cycle(0)
{
}

// This is where all the real work gets done to draw into the view
void FaderSaver::Tick()
{
	const int CYCLES = 32;
	rgb_color color;
	int brightness = ((CYCLES - cycle) * 140) / CYCLES;
	
	color.red = brightness;
	color.green = brightness;
	color.blue = brightness;
	View()->SetHighColor(color);
	View()->FillRect(View()->Bounds(), B_SOLID_HIGH);
	
	cycle = (cycle + 1) % CYCLES;
}


Fader::Fader(BMessage* message)
 : BlanketModule(message)
{
}

BlanketModule::Saver* Fader::InstantiateSaver(BView *v, bool /*preview*/)
{
	return new FaderSaver(this, v);
}

BlanketModule::Config* Fader::InstantiateConfig(BView *v)
{
	return new ScrollConfig(this, v, 
	    "Simple demonstration saver called Fader based on the new "
	    "Blanket saver base classes"
	);
}	
